diff --git a/gcc/config/mips/mips.c b/gcc/config/mips/mips.c
index 143169b..d50fc16 100644
--- a/gcc/config/mips/mips.c
+++ b/gcc/config/mips/mips.c
@@ -1433,7 +1433,7 @@ mips_insert_attributes (tree decl, tree *attributes)
 	error ("%qE cannot have both %qs and %qs attributes",
 	       DECL_NAME (decl), "mips16", "micromips");
 
-      if (TARGET_FLIP_MIPS16
+      if (GCC_OPTION (TARGET_FLIP_MIPS16)
 	  && !DECL_ARTIFICIAL (decl)
 	  && compression_flags == 0
 	  && nocompression_flags == 0)
@@ -1783,8 +1783,8 @@ mips_symbol_binds_local_p (const_rtx x)
 static bool
 mips_rtx_constant_in_small_data_p (enum machine_mode mode)
 {
-  return (!TARGET_EMBEDDED_DATA
-	  && TARGET_LOCAL_SDATA
+  return (!GCC_OPTION (TARGET_EMBEDDED_DATA)
+	  && GCC_OPTION (TARGET_LOCAL_SDATA)
 	  && GET_MODE_SIZE (mode) <= mips_small_data_threshold);
 }
 
@@ -1876,7 +1876,7 @@ mips_classify_symbol (const_rtx x, enum mips_symbol_context context)
 
   /* Do not use small-data accesses for weak symbols; they may end up
      being zero.  */
-  if (TARGET_GPOPT && SYMBOL_REF_SMALL_P (x) && !SYMBOL_REF_WEAK (x))
+  if (GCC_OPTION (TARGET_GPOPT) && SYMBOL_REF_SMALL_P (x) && !SYMBOL_REF_WEAK (x))
     return SYMBOL_GP_RELATIVE;
 
   /* Don't use GOT accesses for locally-binding symbols when -mno-shared
@@ -3995,7 +3995,7 @@ mips_rtx_costs (rtx x, int code, int outer_code, int opno ATTRIBUTE_UNUSED,
     case MINUS:
       if (float_mode_p
 	  && (ISA_HAS_NMADD4_NMSUB4 || ISA_HAS_NMADD3_NMSUB3)
-	  && TARGET_FUSED_MADD
+	  && GCC_OPTION (TARGET_FUSED_MADD)
 	  && !HONOR_NANS (mode)
 	  && !HONOR_SIGNED_ZEROS (mode))
 	{
@@ -4028,7 +4028,7 @@ mips_rtx_costs (rtx x, int code, int outer_code, int opno ATTRIBUTE_UNUSED,
 	  /* If this is part of a MADD or MSUB, treat the PLUS as
 	     being free.  */
 	  if ((ISA_HAS_FP_MADD4_MSUB4 || ISA_HAS_FP_MADD3_MSUB3)
-	      && TARGET_FUSED_MADD
+	      && GCC_OPTION (TARGET_FUSED_MADD)
 	      && GET_CODE (XEXP (x, 0)) == MULT)
 	    *total = 0;
 	  else
@@ -4047,7 +4047,7 @@ mips_rtx_costs (rtx x, int code, int outer_code, int opno ATTRIBUTE_UNUSED,
     case NEG:
       if (float_mode_p
 	  && (ISA_HAS_NMADD4_NMSUB4 || ISA_HAS_NMADD3_NMSUB3)
-	  && TARGET_FUSED_MADD
+	  && GCC_OPTION (TARGET_FUSED_MADD)
 	  && !HONOR_NANS (mode)
 	  && HONOR_SIGNED_ZEROS (mode))
 	{
@@ -4092,7 +4092,7 @@ mips_rtx_costs (rtx x, int code, int outer_code, int opno ATTRIBUTE_UNUSED,
       /* Check for a reciprocal.  */
       if (float_mode_p
 	  && ISA_HAS_FP_RECIP_RSQRT (mode)
-	  && flag_unsafe_math_optimizations
+	  && GCC_OPTION (flag_unsafe_math_optimizations)
 	  && XEXP (x, 0) == CONST1_RTX (mode))
 	{
 	  if (outer_code == SQRT || GET_CODE (XEXP (x, 1)) == SQRT)
@@ -5115,7 +5115,7 @@ mips_get_arg_info (struct mips_arg_info *info, const CUMULATIVE_ARGS *cum,
 
      The checks against UNITS_PER_FPVALUE handle the soft-float and
      single-float cases.  */
-  switch (mips_abi)
+  switch (GCC_OPTION (mips_abi))
     {
     case ABI_EABI:
       /* The EABI conventions have traditionally been defined in terms
@@ -5189,7 +5189,7 @@ mips_get_arg_info (struct mips_arg_info *info, const CUMULATIVE_ARGS *cum,
   /* Set REG_OFFSET to the register count we're interested in.
      The EABI allocates the floating-point registers separately,
      but the other ABIs allocate them like integer registers.  */
-  info->reg_offset = (mips_abi == ABI_EABI && info->fpr_p
+  info->reg_offset = (GCC_OPTION (mips_abi) == ABI_EABI && info->fpr_p
 		      ? cum->num_fprs
 		      : cum->num_gprs);
 
@@ -5218,7 +5218,7 @@ mips_arg_regno (const struct mips_arg_info *info, bool hard_float_p)
 {
   if (!info->fpr_p || !hard_float_p)
     return GP_ARG_FIRST + info->reg_offset;
-  else if (mips_abi == ABI_32 && TARGET_DOUBLE_FLOAT && info->reg_offset > 0)
+  else if (GCC_OPTION (mips_abi) == ABI_32 && TARGET_DOUBLE_FLOAT && info->reg_offset > 0)
     /* In o32, the second argument is always passed in $f14
        for TARGET_DOUBLE_FLOAT, regardless of whether the
        first argument was a word or doubleword.  */
@@ -5387,7 +5387,7 @@ mips_function_arg_advance (cumulative_args_t cum_v, enum machine_mode mode,
      num_gprs to MAX_ARGS_IN_REGISTERS if a doubleword-aligned
      argument required us to skip the final GPR and pass the whole
      argument on the stack.  */
-  if (mips_abi != ABI_EABI || !info.fpr_p)
+  if (GCC_OPTION (mips_abi) != ABI_EABI || !info.fpr_p)
     cum->num_gprs = info.reg_offset + info.reg_words;
   else if (info.reg_words > 0)
     cum->num_fprs += MAX_FPRS_PER_FMT;
@@ -5452,12 +5452,12 @@ mips_pad_arg_upward (enum machine_mode mode, const_tree type)
     return false;
 
   /* Big-endian o64 pads floating-point arguments downward.  */
-  if (mips_abi == ABI_O64)
+  if (GCC_OPTION (mips_abi) == ABI_O64)
     if (type != 0 ? FLOAT_TYPE_P (type) : GET_MODE_CLASS (mode) == MODE_FLOAT)
       return false;
 
   /* Other types are padded upward for o32, o64, n32 and n64.  */
-  if (mips_abi != ABI_EABI)
+  if (GCC_OPTION (mips_abi) != ABI_EABI)
     return true;
 
   /* Arguments smaller than a stack slot are padded downward.  */
@@ -5490,7 +5490,7 @@ mips_pass_by_reference (cumulative_args_t cum ATTRIBUTE_UNUSED,
 			enum machine_mode mode, const_tree type,
 			bool named ATTRIBUTE_UNUSED)
 {
-  if (mips_abi == ABI_EABI)
+  if (GCC_OPTION (mips_abi) == ABI_EABI)
     {
       int size;
 
@@ -5517,7 +5517,7 @@ mips_callee_copies (cumulative_args_t cum ATTRIBUTE_UNUSED,
 		    enum machine_mode mode ATTRIBUTE_UNUSED,
 		    const_tree type ATTRIBUTE_UNUSED, bool named)
 {
-  return mips_abi == ABI_EABI && named;
+  return GCC_OPTION (mips_abi) == ABI_EABI && named;
 }
 
 /* See whether VALTYPE is a record whose fields should be returned in
@@ -5701,7 +5701,7 @@ mips_function_value_1 (const_tree valtype, const_tree fn_decl_or_type,
 	 For example, "struct { some_type x; }" and "union { some_type x; }"
 	 are returned in the same way as a bare "some_type" would be.
 	 Other ABIs only use FPRs for scalar, complex or vector types.  */
-      if (mips_abi != ABI_EABI && !FLOAT_TYPE_P (valtype))
+      if (GCC_OPTION (mips_abi) != ABI_EABI && !FLOAT_TYPE_P (valtype))
 	return gen_rtx_REG (mode, GP_RETURN);
     }
 
@@ -6299,7 +6299,7 @@ mips_start_function_definition (const char *name, bool mips16_p)
     fprintf (asm_out_file, "\t.set\tnomicromips\n");
 #endif
 
-  if (!flag_inhibit_size_directive)
+  if (!GCC_OPTION (flag_inhibit_size_directive))
     {
       fputs ("\t.ent\t", asm_out_file);
       assemble_name (asm_out_file, name);
@@ -6318,7 +6318,7 @@ mips_start_function_definition (const char *name, bool mips16_p)
 static void
 mips_end_function_definition (const char *name)
 {
-  if (!flag_inhibit_size_directive)
+  if (!GCC_OPTION (flag_inhibit_size_directive))
     {
       fputs ("\t.end\t", asm_out_file);
       assemble_name (asm_out_file, name);
@@ -7122,7 +7122,7 @@ mips_call_may_need_jalx_p (tree decl)
   /* When -minterlink-compressed is in effect, assume that functions
      could use a different encoding mode unless an attribute explicitly
      tells us otherwise.  */
-  if (TARGET_INTERLINK_COMPRESSED)
+  if (GCC_OPTION (TARGET_INTERLINK_COMPRESSED))
     {
       if (!TARGET_COMPRESSION
 	  && mips_get_compress_off_flags (DECL_ATTRIBUTES (decl)) ==0)
@@ -7429,7 +7429,7 @@ mips_expand_block_move (rtx dest, rtx src, rtx length)
 	  mips_block_move_straight (dest, src, INTVAL (length));
 	  return true;
 	}
-      else if (optimize)
+      else if (GCC_OPTION (optimize))
 	{
 	  mips_block_move_loop (dest, src, INTVAL (length),
 				MIPS_MAX_MOVE_BYTES_PER_LOOP_ITER);
@@ -7811,9 +7811,9 @@ static bool
 mips_split_addresses_p (void)
 {
   return (TARGET_SPLIT_ADDRESSES
-	  && optimize
+	  && GCC_OPTION (optimize)
 	  && !TARGET_MIPS16
-	  && !flag_pic
+	  && !GCC_OPTION (flag_pic)
 	  && !ABI_HAS_64BIT_SYMBOLS);
 }
 
@@ -7893,7 +7893,7 @@ mips_init_relocs (void)
 	/* Expose the use of $28 as soon as possible.  */
 	mips_split_hi_p[SYMBOL_GOT_PAGE_OFST] = true;
 
-      if (TARGET_XGOT)
+      if (GCC_OPTION (TARGET_XGOT))
 	{
 	  /* The HIGH and LO_SUM are matched by special .md patterns.  */
 	  mips_split_p[SYMBOL_GOT_DISP] = true;
@@ -8427,7 +8427,7 @@ mips_encode_section_info (tree decl, rtx rtl, int first)
       tree type = TREE_TYPE (decl);
 
       /* Encode whether the symbol is short or long.  */
-      if ((TARGET_LONG_CALLS && !mips_near_type_p (type))
+      if ((GCC_OPTION (TARGET_LONG_CALLS) && !mips_near_type_p (type))
 	  || mips_far_type_p (type))
 	SYMBOL_REF_FLAGS (symbol) |= SYMBOL_FLAG_LONG_CALL;
     }
@@ -8470,8 +8470,8 @@ mips_function_rodata_section (tree decl)
 	  rname[14] = 'd';
 	  return get_section (rname, SECTION_LINKONCE | SECTION_WRITE, decl);
 	}
-      else if (flag_function_sections
-	       && flag_data_sections
+      else if (GCC_OPTION (flag_function_sections)
+	       && GCC_OPTION (flag_data_sections)
 	       && strncmp (name, ".text.", 6) == 0)
 	{
 	  char *rname = ASTRDUP (name);
@@ -8512,7 +8512,7 @@ mips_in_small_data_p (const_tree decl)
       if (mips_lo_relocs[SYMBOL_GP_RELATIVE] || !DECL_EXTERNAL (decl))
 	return true;
     }
-  else if (TARGET_EMBEDDED_DATA)
+  else if (GCC_OPTION (TARGET_EMBEDDED_DATA))
     {
       /* Don't put constants into the small data section: we want them
 	 to be in ROM rather than RAM.  */
@@ -8526,11 +8526,11 @@ mips_in_small_data_p (const_tree decl)
     }
 
   /* Enforce -mlocal-sdata.  */
-  if (!TARGET_LOCAL_SDATA && !TREE_PUBLIC (decl))
+  if (!GCC_OPTION (TARGET_LOCAL_SDATA) && !TREE_PUBLIC (decl))
     return false;
 
   /* Enforce -mextern-sdata.  */
-  if (!TARGET_EXTERN_SDATA && DECL_P (decl))
+  if (!GCC_OPTION (TARGET_EXTERN_SDATA) && DECL_P (decl))
     {
       if (DECL_EXTERNAL (decl))
 	return false;
@@ -8630,7 +8630,7 @@ mips_output_filename (FILE *stream, const char *name)
 {
   /* If we are emitting DWARF-2, let dwarf2out handle the ".file"
      directives.  */
-  if (write_symbols == DWARF2_DEBUG)
+  if (GCC_OPTION (write_symbols) == DWARF2_DEBUG)
     return;
   else if (mips_output_filename_first_time)
     {
@@ -8643,7 +8643,7 @@ mips_output_filename (FILE *stream, const char *name)
     }
   /* If we are emitting stabs, let dbxout.c handle this (except for
      the mips_output_filename_first_time case).  */
-  else if (write_symbols == DBX_DEBUG)
+  else if (GCC_OPTION (write_symbols) == DBX_DEBUG)
     return;
   else if (name != current_function_file
 	   && strcmp (name, current_function_file) != 0)
@@ -8858,8 +8858,8 @@ mips_output_aligned_decl_common (FILE *stream, tree decl, const char *name,
 {
   /* If the target wants uninitialized const declarations in
      .rdata then don't put them in .comm.  */
-  if (TARGET_EMBEDDED_DATA
-      && TARGET_UNINIT_CONST_IN_RODATA
+  if (GCC_OPTION (TARGET_EMBEDDED_DATA)
+      && GCC_OPTION (TARGET_UNINIT_CONST_IN_RODATA)
       && TREE_CODE (decl) == VAR_DECL
       && TREE_READONLY (decl)
       && (DECL_INITIAL (decl) == 0 || DECL_INITIAL (decl) == error_mark_node))
@@ -8893,7 +8893,7 @@ mips_declare_object_name (FILE *stream, const char *name,
 #endif
 
   size_directive_output = 0;
-  if (!flag_inhibit_size_directive && DECL_SIZE (decl))
+  if (!GCC_OPTION (flag_inhibit_size_directive) && DECL_SIZE (decl))
     {
       HOST_WIDE_INT size;
 
@@ -8913,7 +8913,7 @@ mips_finish_declare_object (FILE *stream, tree decl, int top_level, int at_end)
   const char *name;
 
   name = XSTR (XEXP (DECL_RTL (decl), 0), 0);
-  if (!flag_inhibit_size_directive
+  if (!GCC_OPTION (flag_inhibit_size_directive)
       && DECL_SIZE (decl) != 0
       && !at_end
       && top_level
@@ -8935,7 +8935,7 @@ mips_finish_declare_object (FILE *stream, tree decl, int top_level, int at_end)
 static const char *
 mips_mdebug_abi_name (void)
 {
-  switch (mips_abi)
+  switch (GCC_OPTION (mips_abi))
     {
     case ABI_32:
       return "abi32";
@@ -8974,21 +8974,21 @@ mips_file_start (void)
      EABI from long64 forms.  Emit a special section to help tools
      such as GDB.  Do the same for o64, which is sometimes used with
      -mlong64.  */
-  if (mips_abi == ABI_EABI || mips_abi == ABI_O64)
+  if (GCC_OPTION (mips_abi) == ABI_EABI || GCC_OPTION (mips_abi) == ABI_O64)
     fprintf (asm_out_file, "\t.section .gcc_compiled_long%d\n"
 	     "\t.previous\n", TARGET_LONG64 ? 64 : 32);
 
   /* Record the NaN encoding.  */
-  if (HAVE_AS_NAN || mips_nan != MIPS_IEEE_754_DEFAULT)
+  if (HAVE_AS_NAN || GCC_OPTION (mips_nan) != MIPS_IEEE_754_DEFAULT)
     fprintf (asm_out_file, "\t.nan\t%s\n",
-	     mips_nan == MIPS_IEEE_754_2008 ? "2008" : "legacy");
+	     GCC_OPTION (mips_nan) == MIPS_IEEE_754_2008 ? "2008" : "legacy");
 
 #ifdef HAVE_AS_GNU_ATTRIBUTE
   {
     int attr;
 
     /* No floating-point operations, -mno-float.  */
-    if (TARGET_NO_FLOAT)
+    if (GCC_OPTION (TARGET_NO_FLOAT))
       attr = 0;
     /* Soft-float code, -msoft-float.  */
     else if (!TARGET_HARD_FLOAT_ABI)
@@ -9015,7 +9015,7 @@ mips_file_start (void)
 	fprintf (asm_out_file, "\t.option\tpic0\n");
     }
 
-  if (flag_verbose_asm)
+  if (GCC_OPTION (flag_verbose_asm))
     fprintf (asm_out_file, "\n%s -G value = %d, Arch = %s, ISA = %d\n",
 	     ASM_COMMENT_START,
 	     mips_small_data_threshold, mips_arch_info->name, mips_isa);
@@ -9808,7 +9808,7 @@ mips_interrupt_extra_call_saved_reg_p (unsigned int regno)
   if (MD_REG_P (regno))
     return true;
 
-  if (TARGET_DSP && DSP_ACC_REG_P (regno))
+  if (GCC_OPTION (TARGET_DSP) && DSP_ACC_REG_P (regno))
     return true;
 
   if (GP_REG_P (regno) && !cfun->machine->use_shadow_register_set_p)
@@ -10774,7 +10774,7 @@ mips_output_function_prologue (FILE *file, HOST_WIDE_INT size ATTRIBUTE_UNUSED)
   mips_start_function_definition (fnname, TARGET_MIPS16);
 
   /* Output MIPS-specific frame information.  */
-  if (!flag_inhibit_size_directive)
+  if (!GCC_OPTION (flag_inhibit_size_directive))
     {
       const struct mips_frame_info *frame;
 
@@ -11114,10 +11114,10 @@ mips_expand_prologue (void)
   frame = &cfun->machine->frame;
   size = frame->total_size;
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = size;
 
-  if (flag_stack_check == STATIC_BUILTIN_STACK_CHECK)
+  if (GCC_OPTION (flag_stack_check) == STATIC_BUILTIN_STACK_CHECK)
     {
       if (crtl->is_leaf && !cfun->calls_alloca)
 	{
@@ -12243,7 +12243,7 @@ mips_vector_mode_supported_p (enum machine_mode mode)
     case V2UHAmode:
     case V4QQmode:
     case V4UQQmode:
-      return TARGET_DSP;
+      return GCC_OPTION (TARGET_DSP);
 
     case V2SImode:
     case V4HImode:
@@ -12283,7 +12283,7 @@ mips_preferred_simd_mode (enum machine_mode mode ATTRIBUTE_UNUSED)
 static void
 mips_init_libfuncs (void)
 {
-  if (TARGET_FIX_VR4120)
+  if (GCC_OPTION (TARGET_FIX_VR4120))
     {
       /* Register the special divsi3 and modsi3 functions needed to work
 	 around VR4120 division errata.  */
@@ -12358,7 +12358,7 @@ mips_process_load_label (rtx target)
   HOST_WIDE_INT offset;
 
   mips_multi_start ();
-  switch (mips_abi)
+  switch (GCC_OPTION (mips_abi))
     {
     case ABI_N32:
       mips_multi_add_insn ("lw\t%@,%%got_page(%0)(%+)", target, 0);
@@ -12529,7 +12529,7 @@ mips_output_conditional_branch (rtx insn, rtx *operands,
       if (!INSN_ANNULLED_BRANCH_P (insn))
 	{
 	  final_scan_insn (XVECEXP (final_sequence, 0, 1),
-			   asm_out_file, optimize, 1, NULL);
+			   asm_out_file, GCC_OPTION (optimize), 1, NULL);
 	  INSN_DELETED_P (XVECEXP (final_sequence, 0, 1)) = 1;
 	}
       else
@@ -12554,7 +12554,7 @@ mips_output_conditional_branch (rtx insn, rtx *operands,
       if (INSN_ANNULLED_BRANCH_P (insn))
 	{
 	  final_scan_insn (XVECEXP (final_sequence, 0, 1),
-			   asm_out_file, optimize, 1, NULL);
+			   asm_out_file, GCC_OPTION (optimize), 1, NULL);
 	  INSN_DELETED_P (XVECEXP (final_sequence, 0, 1)) = 1;
 	}
       else
@@ -13772,12 +13772,12 @@ struct mips_builtin_description {
 AVAIL_ALL (hard_float, TARGET_HARD_FLOAT_ABI)
 AVAIL_NON_MIPS16 (paired_single, TARGET_PAIRED_SINGLE_FLOAT)
 AVAIL_NON_MIPS16 (sb1_paired_single, TARGET_SB1 && TARGET_PAIRED_SINGLE_FLOAT)
-AVAIL_NON_MIPS16 (mips3d, TARGET_MIPS3D)
-AVAIL_NON_MIPS16 (dsp, TARGET_DSP)
-AVAIL_NON_MIPS16 (dspr2, TARGET_DSPR2)
-AVAIL_NON_MIPS16 (dsp_32, !TARGET_64BIT && TARGET_DSP)
-AVAIL_NON_MIPS16 (dsp_64, TARGET_64BIT && TARGET_DSP)
-AVAIL_NON_MIPS16 (dspr2_32, !TARGET_64BIT && TARGET_DSPR2)
+AVAIL_NON_MIPS16 (mips3d, GCC_OPTION (TARGET_MIPS3D))
+AVAIL_NON_MIPS16 (dsp, GCC_OPTION (TARGET_DSP))
+AVAIL_NON_MIPS16 (dspr2, GCC_OPTION (TARGET_DSPR2))
+AVAIL_NON_MIPS16 (dsp_32, !TARGET_64BIT && GCC_OPTION (TARGET_DSP))
+AVAIL_NON_MIPS16 (dsp_64, TARGET_64BIT && GCC_OPTION (TARGET_DSP))
+AVAIL_NON_MIPS16 (dspr2_32, !TARGET_64BIT && GCC_OPTION (TARGET_DSPR2))
 AVAIL_NON_MIPS16 (loongson, TARGET_LOONGSON_VECTORS)
 AVAIL_NON_MIPS16 (cache, TARGET_CACHE_BUILTIN)
 
@@ -14838,7 +14838,7 @@ mips16_rewrite_pool_refs (rtx *x, void *data)
 static bool
 mips_cfg_in_reorg (void)
 {
-  return (mips_r10k_cache_barrier != R10K_CACHE_BARRIER_NONE
+  return (GCC_OPTION (mips_r10k_cache_barrier) != R10K_CACHE_BARRIER_NONE
 	  || TARGET_RELAX_PIC_CALLS);
 }
 
@@ -15153,7 +15153,7 @@ r10k_needs_protection_p (rtx insn)
   if (CALL_P (insn))
     return for_each_rtx (&PATTERN (insn), r10k_needs_protection_p_call, NULL);
 
-  if (mips_r10k_cache_barrier == R10K_CACHE_BARRIER_STORE)
+  if (GCC_OPTION (mips_r10k_cache_barrier) == R10K_CACHE_BARRIER_STORE)
     {
       note_stores (PATTERN (insn), r10k_needs_protection_p_store, &insn);
       return insn == NULL_RTX;
@@ -16218,9 +16218,9 @@ mips_reorg_process_insns (void)
   /* Code compiled with -mfix-vr4120, -mfix-rm7000 or -mfix-24k can't be
      all noreorder because we rely on the assembler to work around some
      errata.  The R5900 too has several bugs.  */
-  if (TARGET_FIX_VR4120
-      || TARGET_FIX_RM7000
-      || TARGET_FIX_24K
+  if (GCC_OPTION (TARGET_FIX_VR4120)
+      || GCC_OPTION (TARGET_FIX_RM7000)
+      || GCC_OPTION (TARGET_FIX_24K)
       || TARGET_MIPS5900)
     cfun->machine->all_noreorder_p = false;
 
@@ -16228,7 +16228,7 @@ mips_reorg_process_insns (void)
      MFHI instructions.  Note that we avoid using MFLO and MFHI if
      the VR4130 MACC and DMACC instructions are available instead;
      see the *mfhilo_{si,di}_macc patterns.  */
-  if (TARGET_FIX_VR4130 && !ISA_HAS_MACCHI)
+  if (GCC_OPTION (TARGET_FIX_VR4130) && !ISA_HAS_MACCHI)
     cfun->machine->all_noreorder_p = false;
 
   htab.create (37);
@@ -16377,7 +16377,7 @@ mips_df_reorg (void)
   if (TARGET_RELAX_PIC_CALLS)
     mips_annotate_pic_calls ();
 
-  if (mips_r10k_cache_barrier != R10K_CACHE_BARRIER_NONE)
+  if (GCC_OPTION (mips_r10k_cache_barrier) != R10K_CACHE_BARRIER_NONE)
     r10k_insert_cache_barriers ();
 
   df_finish_pass (false);
@@ -16707,40 +16707,40 @@ mips_set_compression_mode (unsigned int compression_mode)
     return;
 
   /* Restore base settings of various flags.  */
-  target_flags = mips_base_target_flags;
-  flag_schedule_insns = mips_base_schedule_insns;
-  flag_reorder_blocks_and_partition = mips_base_reorder_blocks_and_partition;
-  flag_move_loop_invariants = mips_base_move_loop_invariants;
-  align_loops = mips_base_align_loops;
-  align_jumps = mips_base_align_jumps;
-  align_functions = mips_base_align_functions;
-  target_flags &= ~(MASK_MIPS16 | MASK_MICROMIPS);
-  target_flags |= compression_mode;
+  GCC_OPTION (target_flags) = mips_base_target_flags;
+  GCC_OPTION (flag_schedule_insns) = mips_base_schedule_insns;
+  GCC_OPTION (flag_reorder_blocks_and_partition) = mips_base_reorder_blocks_and_partition;
+  GCC_OPTION (flag_move_loop_invariants) = mips_base_move_loop_invariants;
+  GCC_OPTION (align_loops) = mips_base_align_loops;
+  GCC_OPTION (align_jumps) = mips_base_align_jumps;
+  GCC_OPTION (align_functions) = mips_base_align_functions;
+  GCC_OPTION (target_flags) &= ~(MASK_MIPS16 | MASK_MICROMIPS);
+  GCC_OPTION (target_flags) |= compression_mode;
 
   if (compression_mode & MASK_MIPS16)
     {
       /* Switch to MIPS16 mode.  */
-      target_flags |= MASK_MIPS16;
+      GCC_OPTION (target_flags) |= MASK_MIPS16;
 
       /* Turn off SYNCI if it was on, MIPS16 doesn't support it.  */
-      target_flags &= ~MASK_SYNCI;
+      GCC_OPTION (target_flags) &= ~MASK_SYNCI;
 
       /* Don't run the scheduler before reload, since it tends to
          increase register pressure.  */
-      flag_schedule_insns = 0;
+      GCC_OPTION (flag_schedule_insns) = 0;
 
       /* Don't do hot/cold partitioning.  mips16_lay_out_constants expects
 	 the whole function to be in a single section.  */
-      flag_reorder_blocks_and_partition = 0;
+      GCC_OPTION (flag_reorder_blocks_and_partition) = 0;
 
       /* Don't move loop invariants, because it tends to increase
 	 register pressure.  It also introduces an extra move in cases
 	 where the constant is the first operand in a two-operand binary
 	 instruction, or when it forms a register argument to a functon
 	 call.  */
-      flag_move_loop_invariants = 0;
+      GCC_OPTION (flag_move_loop_invariants) = 0;
 
-      target_flags |= MASK_EXPLICIT_RELOCS;
+      GCC_OPTION (target_flags) |= MASK_EXPLICIT_RELOCS;
 
       /* Experiments suggest we get the best overall section-anchor
 	 results from using the range of an unextended LW or SW.  Code
@@ -16753,17 +16753,17 @@ mips_set_compression_mode (unsigned int compression_mode)
       targetm.const_anchor = 0;
 
       /* MIPS16 has no BAL instruction.  */
-      target_flags &= ~MASK_RELAX_PIC_CALLS;
+      GCC_OPTION (target_flags) &= ~MASK_RELAX_PIC_CALLS;
 
       /* The R4000 errata don't apply to any known MIPS16 cores.
 	 It's simpler to make the R4000 fixes and MIPS16 mode
 	 mutually exclusive.  */
-      target_flags &= ~MASK_FIX_R4000;
+      GCC_OPTION (target_flags) &= ~MASK_FIX_R4000;
 
-      if (flag_pic && !TARGET_OLDABI)
+      if (GCC_OPTION (flag_pic) && !TARGET_OLDABI)
 	sorry ("MIPS16 PIC for ABIs other than o32 and o64");
 
-      if (TARGET_XGOT)
+      if (GCC_OPTION (TARGET_XGOT))
 	sorry ("MIPS16 -mxgot code");
 
       if (TARGET_HARD_FLOAT_ABI && !TARGET_OLDABI)
@@ -16775,17 +16775,17 @@ mips_set_compression_mode (unsigned int compression_mode)
 
       if (TARGET_MICROMIPS)
 	/* Avoid branch likely.  */
-	target_flags &= ~MASK_BRANCHLIKELY;
+	GCC_OPTION (target_flags) &= ~MASK_BRANCHLIKELY;
 
       /* Provide default values for align_* for 64-bit targets.  */
       if (TARGET_64BIT)
 	{
-	  if (align_loops == 0)
-	    align_loops = 8;
-	  if (align_jumps == 0)
-	    align_jumps = 8;
-	  if (align_functions == 0)
-	    align_functions = 8;
+	  if (GCC_OPTION (align_loops) == 0)
+	    GCC_OPTION (align_loops) = 8;
+	  if (GCC_OPTION (align_jumps) == 0)
+	    GCC_OPTION (align_jumps) = 8;
+	  if (GCC_OPTION (align_functions) == 0)
+	    GCC_OPTION (align_functions) = 8;
 	}
 
       targetm.min_anchor_offset = -32768;
@@ -16923,7 +16923,7 @@ mips_option_override (void)
   int i, start, regno, mode;
 
   if (global_options_set.x_mips_isa_option)
-    mips_isa_option_info = &mips_cpu_info_table[mips_isa_option];
+    mips_isa_option_info = &mips_cpu_info_table[GCC_OPTION (mips_isa_option)];
 
 #ifdef SUBTARGET_OVERRIDE_OPTIONS
   SUBTARGET_OVERRIDE_OPTIONS;
@@ -16936,21 +16936,21 @@ mips_option_override (void)
   /* Save the base compression state and process flags as though we
      were generating uncompressed code.  */
   mips_base_compression_flags = TARGET_COMPRESSION;
-  target_flags &= ~TARGET_COMPRESSION;
+  GCC_OPTION (target_flags) &= ~TARGET_COMPRESSION;
 
   /* -mno-float overrides -mhard-float and -msoft-float.  */
-  if (TARGET_NO_FLOAT)
+  if (GCC_OPTION (TARGET_NO_FLOAT))
     {
-      target_flags |= MASK_SOFT_FLOAT_ABI;
+      GCC_OPTION (target_flags) |= MASK_SOFT_FLOAT_ABI;
       target_flags_explicit |= MASK_SOFT_FLOAT_ABI;
     }
 
-  if (TARGET_FLIP_MIPS16)
-    TARGET_INTERLINK_COMPRESSED = 1;
+  if (GCC_OPTION (TARGET_FLIP_MIPS16))
+    GCC_OPTION (TARGET_INTERLINK_COMPRESSED) = 1;
 
   /* Set the small data limit.  */
   mips_small_data_threshold = (global_options_set.x_g_switch_value
-			       ? g_switch_value
+			       ? GCC_OPTION (g_switch_value)
 			       : MIPS_DEFAULT_GVALUE);
 
   /* The following code determines the architecture and register size.
@@ -16958,7 +16958,7 @@ mips_option_override (void)
      The GAS and GCC code should be kept in sync as much as possible.  */
 
   if (global_options_set.x_mips_arch_option)
-    mips_set_architecture (mips_cpu_info_from_opt (mips_arch_option));
+    mips_set_architecture (mips_cpu_info_from_opt (GCC_OPTION (mips_arch_option)));
 
   if (mips_isa_option_info != 0)
     {
@@ -16980,7 +16980,7 @@ mips_option_override (void)
 
   /* Optimize for mips_arch, unless -mtune selects a different processor.  */
   if (global_options_set.x_mips_tune_option)
-    mips_set_tune (mips_cpu_info_from_opt (mips_tune_option));
+    mips_set_tune (mips_cpu_info_from_opt (GCC_OPTION (mips_tune_option)));
 
   if (mips_tune_info == 0)
     mips_set_tune (mips_arch_info);
@@ -17002,9 +17002,9 @@ mips_option_override (void)
 	 Restrict ourselves to 32-bit registers if that's all the
 	 processor has, or if the ABI cannot handle 64-bit registers.  */
       if (ABI_NEEDS_32BIT_REGS || !ISA_HAS_64BIT_REGS)
-	target_flags &= ~MASK_64BIT;
+	GCC_OPTION (target_flags) &= ~MASK_64BIT;
       else
-	target_flags |= MASK_64BIT;
+	GCC_OPTION (target_flags) |= MASK_64BIT;
     }
 
   if ((target_flags_explicit & MASK_FLOAT64) != 0)
@@ -17018,7 +17018,7 @@ mips_option_override (void)
 	  if (!ISA_HAS_MXHC1)
 	    error ("%<-mgp32%> and %<-mfp64%> can only be combined if"
 		   " the target supports the mfhc1 and mthc1 instructions");
-	  else if (mips_abi != ABI_32)
+	  else if (GCC_OPTION (mips_abi) != ABI_32)
 	    error ("%<-mgp32%> and %<-mfp64%> can only be combined when using"
 		   " the o32 ABI");
 	}
@@ -17028,9 +17028,9 @@ mips_option_override (void)
       /* -msingle-float selects 32-bit float registers.  Otherwise the
 	 float registers should be the same size as the integer ones.  */
       if (TARGET_64BIT && TARGET_DOUBLE_FLOAT)
-	target_flags |= MASK_FLOAT64;
+	GCC_OPTION (target_flags) |= MASK_FLOAT64;
       else
-	target_flags &= ~MASK_FLOAT64;
+	GCC_OPTION (target_flags) &= ~MASK_FLOAT64;
     }
 
   /* End of code shared with GAS.  */
@@ -17046,11 +17046,11 @@ mips_option_override (void)
     {
       if (TARGET_LONG64)
 	{
-	  if (mips_abi == ABI_N32)
+	  if (GCC_OPTION (mips_abi) == ABI_N32)
 	    error ("%qs is incompatible with %qs", "-mabi=n32", "-mlong64");
-	  else if (mips_abi == ABI_32)
+	  else if (GCC_OPTION (mips_abi) == ABI_32)
 	    error ("%qs is incompatible with %qs", "-mabi=32", "-mlong64");
-	  else if (mips_abi == ABI_O64 && TARGET_ABICALLS)
+	  else if (GCC_OPTION (mips_abi) == ABI_O64 && TARGET_ABICALLS)
 	    /* We have traditionally allowed non-abicalls code to use
 	       an LP64 form of o64.  However, it would take a bit more
 	       effort to support the combination of 32-bit GOT entries
@@ -17061,31 +17061,31 @@ mips_option_override (void)
 	}
       else
 	{
-	  if (mips_abi == ABI_64)
+	  if (GCC_OPTION (mips_abi) == ABI_64)
 	    error ("%qs is incompatible with %qs", "-mabi=64", "-mlong32");
 	}
     }
   else
     {
-      if ((mips_abi == ABI_EABI && TARGET_64BIT) || mips_abi == ABI_64)
-	target_flags |= MASK_LONG64;
+      if ((GCC_OPTION (mips_abi) == ABI_EABI && TARGET_64BIT) || GCC_OPTION (mips_abi) == ABI_64)
+	GCC_OPTION (target_flags) |= MASK_LONG64;
       else
-	target_flags &= ~MASK_LONG64;
+	GCC_OPTION (target_flags) &= ~MASK_LONG64;
     }
 
   if (!TARGET_OLDABI)
-    flag_pcc_struct_return = 0;
+    GCC_OPTION (flag_pcc_struct_return) = 0;
 
   /* Decide which rtx_costs structure to use.  */
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     mips_cost = &mips_rtx_cost_optimize_size;
   else
     mips_cost = &mips_rtx_cost_data[mips_tune];
 
   /* If the user hasn't specified a branch cost, use the processor's
      default.  */
-  if (mips_branch_cost == 0)
-    mips_branch_cost = mips_cost->branch_cost;
+  if (GCC_OPTION (mips_branch_cost) == 0)
+    GCC_OPTION (mips_branch_cost) = mips_cost->branch_cost;
 
   /* If neither -mbranch-likely nor -mno-branch-likely was given
      on the command line, set MASK_BRANCHLIKELY based on the target
@@ -17095,11 +17095,11 @@ mips_option_override (void)
   if ((target_flags_explicit & MASK_BRANCHLIKELY) == 0)
     {
       if (ISA_HAS_BRANCHLIKELY
-	  && (optimize_size
+	  && (GCC_OPTION (optimize_size)
 	      || (mips_tune_info->tune_flags & PTF_AVOID_BRANCHLIKELY) == 0))
-	target_flags |= MASK_BRANCHLIKELY;
+	GCC_OPTION (target_flags) |= MASK_BRANCHLIKELY;
       else
-	target_flags &= ~MASK_BRANCHLIKELY;
+	GCC_OPTION (target_flags) &= ~MASK_BRANCHLIKELY;
     }
   else if (TARGET_BRANCHLIKELY && !ISA_HAS_BRANCHLIKELY)
     warning (0, "the %qs architecture does not support branch-likely"
@@ -17112,25 +17112,25 @@ mips_option_override (void)
     {
       if (ISA_HAS_MADD_MSUB &&
           (mips_tune_info->tune_flags & PTF_AVOID_IMADD) == 0)
-	target_flags |= MASK_IMADD;
+	GCC_OPTION (target_flags) |= MASK_IMADD;
       else
-	target_flags &= ~MASK_IMADD;
+	GCC_OPTION (target_flags) &= ~MASK_IMADD;
     }
   else if (TARGET_IMADD && !ISA_HAS_MADD_MSUB)
     warning (0, "the %qs architecture does not support madd or msub"
 	     " instructions", mips_arch_info->name);
 
   /* The effect of -mabicalls isn't defined for the EABI.  */
-  if (mips_abi == ABI_EABI && TARGET_ABICALLS)
+  if (GCC_OPTION (mips_abi) == ABI_EABI && TARGET_ABICALLS)
     {
       error ("unsupported combination: %s", "-mabicalls -mabi=eabi");
-      target_flags &= ~MASK_ABICALLS;
+      GCC_OPTION (target_flags) &= ~MASK_ABICALLS;
     }
 
   /* PIC requires -mabicalls.  */
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
-      if (mips_abi == ABI_EABI)
+      if (GCC_OPTION (mips_abi) == ABI_EABI)
 	error ("cannot generate position-independent code for %qs",
 	       "-mabi=eabi");
       else if (!TARGET_ABICALLS)
@@ -17147,30 +17147,30 @@ mips_option_override (void)
        between -mabicalls and -mno-abicalls code.  The non-__PIC__
        variant is usually appropriate for TARGET_ABICALLS_PIC0, as
        long as any indirect jumps use $25.  */
-    flag_pic = 1;
+    GCC_OPTION (flag_pic) = 1;
 
   /* -mvr4130-align is a "speed over size" optimization: it usually produces
      faster code, but at the expense of more nops.  Enable it at -O3 and
      above.  */
-  if (optimize > 2 && (target_flags_explicit & MASK_VR4130_ALIGN) == 0)
-    target_flags |= MASK_VR4130_ALIGN;
+  if (GCC_OPTION (optimize) > 2 && (target_flags_explicit & MASK_VR4130_ALIGN) == 0)
+    GCC_OPTION (target_flags) |= MASK_VR4130_ALIGN;
 
   /* Prefer a call to memcpy over inline code when optimizing for size,
      though see MOVE_RATIO in mips.h.  */
-  if (optimize_size && (target_flags_explicit & MASK_MEMCPY) == 0)
-    target_flags |= MASK_MEMCPY;
+  if (GCC_OPTION (optimize_size) && (target_flags_explicit & MASK_MEMCPY) == 0)
+    GCC_OPTION (target_flags) |= MASK_MEMCPY;
 
   /* If we have a nonzero small-data limit, check that the -mgpopt
      setting is consistent with the other target flags.  */
   if (mips_small_data_threshold > 0)
     {
-      if (!TARGET_GPOPT)
+      if (!GCC_OPTION (TARGET_GPOPT))
 	{
 	  if (!TARGET_EXPLICIT_RELOCS)
 	    error ("%<-mno-gpopt%> needs %<-mexplicit-relocs%>");
 
-	  TARGET_LOCAL_SDATA = false;
-	  TARGET_EXTERN_SDATA = false;
+	  GCC_OPTION (TARGET_LOCAL_SDATA) = false;
+	  GCC_OPTION (TARGET_EXTERN_SDATA) = false;
 	}
       else
 	{
